% immediate_neighbors.m
%
% this covers search movement rules
%
% Checked 06/016/2015 JH
%
%
% INA: 9 searchable patches, search distance 1
% INB: 25 searchable patches, search distance 2
% INC: 49 searchable patches, search distance 3
% IND: 81 searchable patches, search distance 4
%
INA = zeros(L_size, 9);  
INB = zeros(L_size, 25);
INC = zeros(L_size, 49);
IND = zeros(L_size, 81);

if (search >= 1 && m >= 3)
     
  % upper left corner entry
  i = 1;
  INA(i, :) = [NN(i, :), i, i, i, i + m + 1];

  % top row
  for i = 2 : m - 1
    INA(i, :) = [NN(i, :), i, i, i + m - 1, i + m + 1];
  end

  % upper right entry
  i = m;
  INA(i, :) = [NN(i, :), i, i, i, i + m - 1];

  % left side
  for j = 2 : m - 1
    for i = j * m 
      INA(j * m, :) = [NN(i, :), i, i, i - m + 1, i + m + 1];
    end
  end

  % middle entries
  for j = 1 : m - 2
    for i = j * m + 2 : (j + 1) * m - 1
      INA(i, :) = [NN(i, :), i - m - 1, i - m + 1, i + m - 1, i + m + 1];
    end
  end

  % right side
  for j = 1 : m - 2
    for i = j * m + 1
      INA(j * m + 1, :) = [NN(i, :), i, i, i - m - 1, i + m - 1];
    end
  end

  % lower left corner entry
  i = (m - 1) * m + 1;
  INA(i, :) = [NN(i, :), i, i, i, i - m + 1];

  % bottom row
  for i = (m - 1) * m + 2 : m^2 - 1
    INA(i, :) = [NN(i, :), i, i, i - m - 1, i - m + 1];
  end

  % lower right corner entry
  i = m^2;
  INA(i, :) = [NN(i, :), i, i, i, i - m - 1];
    
  %boundary check
  for i = 1 : L_size
      for j = 1 : 9
          if (INA(i, j) <= 0 || INA(i, j) > L_size)
              INA(i, j) = i;
          end
      end
  end
  
end
  
if (search >= 2 && m >= 5)
     
  % upper left corner entry
  i = 1;
  INB(i, :) = [INA(i, :), i, i, i, i, i, i, i, i, i, i, i, i + 2, i + 2*m, ...
      i + m + 2, i + 2*m + 1, i + 2*m + 2];

  % top row
  for i = 2 : m - 1
    INB(i, :) = [INA(i, :), i, i, i, i, i, i, i, i - 2, i + 2, i + 2*m,...
        i + m - 2, i + m + 2, i + 2*m - 2, i + 2*m - 1, i + 2*m + 1, i + 2*m + 2];
  end

  % upper right entry
  i = m;
  INB(i, :) = [INA(i, :), i, i, i, i, i, i, i, i, i, i, i, i - 2, i + 2*m,...
      i + m - 2, i + 2*m - 2, i + 2*m - 1];

  % left side
  for j = 2 : m - 1
    for i = j * m 
      INB(j * m, :) = [INA(i, :), i, i, i, i, i, i - 2*m, i + 2, i + 2*m, ...
          i - 2*m + 1, i - 2*m + 2, i - m + 2, i + m + 2, i + 2*m +1, i + 2*m +2];
    end
  end

  % middle entries
  for j = 1 : m - 2
    for i = j * m + 2 : (j + 1) * m - 1
      INB(i, :) = [INA(i, :), i - 2*m - 2, i - 2*m - 1, i - 2*m, ...
          i - 2*m + 1, i - 2*m + 2, i - m - 2, i - m + 2, i - 2, i + 2, ...
          i + m - 2, i + m + 2, i + 2*m - 2, i + 2*m - 1, i + 2*m, ...
          i + 2*m + 1, i + 2*m + 2];
    end
  end

  % right side
  for j = 1 : m - 2
    for i = j * m + 1
      INB(j * m + 1, :) = [INA(i, :), i, i, i, i, i, i, i, i - 2*m - 2, ...
          i - 2*m - 1, i - 2*m, i - m - 2, i - 2, i + m - 2, i + 2*m - 2, ...
          i + 2*m - 1, i + 2*m];
    end
  end

  % lower left corner entry
  i = (m - 1) * m + 1;
  INB(i, :) = [INA(i, :), i, i, i, i, i, i, i, i, i, i, i, i - 2*m, ...
      i - 2*m + 1, i - 2*m + 2, i - m + 2, i + 2];

  % bottom row
  for i = (m - 1) * m + 2 : m^2 - 1
    INB(i, :) = [INA(i, :), i, i, i, i, i, i, i , i - 2, i + 2, ...
        i - m - 2, i - m + 2, i - 2*m - 2, i - 2*m - 1, i - 2*m, ...
        i - 2*m + 1, i - 2*m + 2];
  end

  % lower right corner entry
  i = m^2;
  INB(i, :) = [INA(i, :), i, i, i, i, i, i, i, i, i, i, i, i - 2*m - 2, ...
      i - 2*m - 1, i - 2*m, i - m - 2, i - 2];
    
  for i = 1 : L_size
      for j = 1 : 25
          if (INB(i, j) <= 0 || INB(i, j) > L_size)
              INB(i, j) = i;
          end
      end
  end
  
end
  
if (search >= 3 && m >= 7)
     
  % upper left corner entry
  i = 1;
  INC(i, :) = [INB(i, :), i, i, i, i, i, i, i, i, i, i, i, i, i, i, ...
      i ,i ,i, i + 3, i + m + 3, i + 2*m + 3, i + 3*m, i + 3*m + 1, ...
      i + 2*m + 3, i + 3*m + 3];

  % top row
  for i = 2 : m - 1
    INC(i, :) = [INB(i, :), i, i, i, i, i, i, i, i, i, i, i, i - 3, ...
        i + 3, i + m - 3, i + m + 3, i + 2*m - 3, i + 2*m + 3, ...
        i + 3*m - 3, i + 3*m - 2, i + 3*m - 1, i + 3*m, i + 3*m + 1, ...
        i + 3*m + 2, i + 3*m + 3];
  end

  % upper right corner entry
  i = m;
  INC(i, :) = [INB(i, :), i, i, i, i, i, i, i, i, i, i, i, i, i, i, ...
      i, i, i, i - 3, i + m - 3, i + 2*m - 3, i + 3*m - 3, i + 3*m - 2, ...
      i + 3*m - 1, i + 3*m];

  % left side
  for j = 2 : m - 1
    for i = j * m 
      INC(j * m, :) = [INB(i, :), i, i, i, i, i, i, i, i, i, i, i, ...
          i - 3*m, i - 3*m + 1, i - 3*m + 2, i - 3*m + 3, i - 2*m + 3, ...
          i - m + 3, i + m, i + m + 3, i + 2*m + 3, i + 3*m, i + 3*m + 1, ...
          i + 3*m + 2, i + 3*m + 3];
    end
  end

  % middle entries
  for j = 1 : m - 2
    for i = j * m + 2 : (j + 1) * m - 1
      INC(i, :) = [INB(i, :), i - 3*m - 3, i - 3*m - 2, i - 3*m - 1, ...
          i - 3*m, i - 3*m + 1, i - 3*m + 2, i - 3*m + 3, i - 2*m - 3, ...
          i - 2*m + 3, i - m - 3, i - m + 3, i - 3, i + 3, i + m - 3, ...
          i + m + 3, i + 2*m - 3, i + 2*m + 3, i + 3*m - 3, i + 3*m - 2, ...
          i + 3*m - 1, i + 3*m, i + 3*m + 1, i + 3*m + 2, i + 3*m + 3];
    end
  end

  % right side
  for j = 1 : m - 2
    for i = j * m + 1
      INC(j * m + 1, :) = [INB(i, :), i, i, i, i, i, i, i, i, i, i, i, ...
          i - 3*m - 3, i - 3*m - 2, i - 3*m - 1, i - 3*m, i - 2*m - 3, ...
          i - m - 3, i - 3, i + m - 3, i + 2*m - 3, i + 3 *m - 3, ...
          i + 3*m - 2, i + 3*m - 1, i + 3*m];
    end
  end

  % lower left corner entry
  i = (m - 1) * m + 1;
  INC(i, :) = [INB(i, :), i, i, i, i, i, i, i, i, i, i, i, i, i, i, i, ...
      i, i, i - 3*m, i - 3*m + 1, i - 3*m + 2, i - 3*m + 3, i - 2*m + 3, ...
      i - m + 3, i + 3];

  % bottom row
  for i = (m - 1) * m + 2 : m^2 - 1
    INC(i, :) = [INB(i, :), i, i, i, i, i, i, i , i, i, i, i, i - 3, ...
        i - m - 3, i - 2*m - 3, i - 3*m - 3, i - 3*m - 2, i - 3*m - 1, ...
        i - 3*m, i - 3*m + 1, i - 3*m + 2, i - 3*m + 3, i - 2*m + 3, ...
        i - m + 3, i + 3];
  end

  % lower right corner entry
  i = m^2;
  INC(i, :) = [INB(i, :), i, i, i, i, i, i, i, i, i, i, i, i, i, i, i, ...
      i, i, i - 3, i - m - 3, i - 2*m - 3, i - 3*m - 3, i - 3*m - 2, ...
      i - 3*m - 1, i - 3*m];
       
 for i = 1 : L_size
      for j = 1 : 49
          if (INC(i, j) <= 0 || INC(i, j) > L_size)
              INC(i, j) = i;
          end
      end
  end
  
end

if (search == 4 && m >= 9)
    
  % upper left corner entry
  i = 1;
  IND(i, :) = [INC(i, :), i, i, i, i, i, i, i, i, i, i, i, i, i, i, ...
      i ,i ,i, i, i, i, i, i, i, i + 4*m, i + 4*m + 1, i + 4*m + 2, ...
      i + 4*m + 3, i + 4*m + 4, i + 3*m + 4, i + 2*m + 4, i + m + 4, i + 4];

  % top row
  for i = 2 : m - 1
    IND(i, :) = [INC(i, :), i, i, i, i, i, i, i, i, i, i, i, i, i, i, ...
        i, i - 4, i + m - 4, i + 2*m - 4, i + 3*m - 4, i + 4*m - 4, ...
        i + 4*m - 3, i + 4*m - 2, i + 4*m - 1, i + 4*m, i + 4*m + 1, ...
        i + 4*m + 2, i + 4*m + 3, i + 4*m + 4, i + 3*m + 4, i + 2*m + 4, ...
        i + m + 4, i + 4];
  end

  % upper right entry
  i = m;
  IND(i, :) = [INC(i, :), i, i, i, i, i, i, i, i, i, i, i, i, i, i, i, ...
      i, i, i, i, i, i, i, i, i - 4, i + m - 4, i + 2*m - 4, i + 3*m - 4, ...
      i + 4*m - 4, i + 4*m - 3, i + 4*m - 2, i + 4*m - 1, i + 4*m];

  % left side
  for j = 2 : m - 1
    for i = j * m 
      IND(j * m, :) = [INC(i, :), i, i, i, i, i, i, i, i, i, i, i, i, i, ...
          i, i, i - 4*m, i - 4*m + 1, i - 4*m + 2, i - 4*m + 3, ...
          i - 4*m + 4, i - 3*m + 4, i - 2*m + 4, i - m + 4, i + 4, ...
          i + m + 4, i + 2*m + 4, i + 3*m + 4, i + 4*m + 4, i + 4*m + 3, ...
          i + 4*m + 2, i + 4*m + 2, i + 4*m];
    end
  end

  % middle entries
  for j = 1 : m - 2
    for i = j * m + 2 : (j + 1) * m - 1
      IND(i, :) = [INC(i, :), i - 4*m - 4, i - 4*m - 3, i - 4*m - 2, ...
          i - 4*m - 1, i - 4*m, i - 4*m + 1, i - 4*m + 2, i - 4*m + 3, ...
          i - 4*m + 4, i + 4*m - 4, i + 4*m - 3, i + 4*m - 2, ...
          i + 4*m - 1, i + 4*m, i + 4*m + 1, i + 4*m + 2, i + 4*m + 3, ...
          i + 4*m + 4, i + 3*m + 4, i + 2*m + 4, i + m + 4, i + 4, ...
          i - m + 4, i - 2*m + 4, i - 3*m + 4, i + 3*m - 4, i + 2*m - 4, ...
          i + m - 4, i - 4, i - m - 4, i - 2*m - 4, i - 3*m - 4];
    end
  end

  % right side
  for j = 1 : m - 2
    for i = j * m + 1
      IND(j * m + 1, :) = [INC(i, :), i, i, i, i, i, i, i, i, i, i, i, ...
          i, i, i, i, i + 4*m - 4, i + 3*m - 4, i + 2*m - 4, i + m - 4, ...
          i - 4, i - m - 4, i - 2*m - 4, i - 3*m - 4, i - 4*m - 4, ...
          i - 4*m - 3, i - 4*m - 2, i - 4*m - 1, i - 4*m, i + 4*m - 3, ...
          i + 4*m - 2, i + 4*m - 1, i + 4*m];
    end
  end

  % lower left corner entry
  i = (m - 1) * m + 1;
  IND(i, :) = [INC(i, :), i, i, i, i, i, i, i, i, i, i, i, i, i, i, ...
      i, i, i, i, i, i, i, i, i, i - 4*m, i - 4*m + 1, i - 4*m + 2, ...
      i - 4*m + 3, i - 4*m + 4, i - 3*m + 4, i - 2*m + 4, i - m + 4, i + 4];

  % bottom row
  for i = (m - 1) * m + 2 : m^2 - 1
    IND(i, :) = [INC(i, :), i, i, i, i, i, i, i, i, i, i, i, i, i, i, ...
        i, i - 4, i - m - 4, i - 2*m - 4, i - 3*m - 4, i - 4*m - 4, ...
        i + 4, i - m + 4, i - 2*m + 4, i - 3*m + 4, i - 4*m + 4, ...
        i - 4*m - 3, i - 4*m - 2, i - 4*m - 1, i - 4*m, i - 4*m + 1, ...
        i - 4*m + 2, i - 4*m + 3];
  end

  % lower right corner entry
  i = m^2;
  IND(i, :) = [INC(i, :), i, i, i, i, i, i, i, i, i, i, i, i, i, i, ...
      i, i, i, i, i, i, i, i, i, i - 4*m, i - 4*m - 1, i - 4*m - 2, ...
      i - 4*m - 3, i - 4*m - 4, i - 3*m - 4, i - 2*m - 4, i - m - 4, i - 4];
        
  for i = 1 : L_size
      for j = 1 : 81
          if (IND(i, j) <= 0 || IND(i, j) > L_size)
              IND(i, j) = i;
          end
      end
  end
  
end
