% nearest_neighbors.m
%
% no user-serviceable parts

% Checked 06/16/2015 JH

% nearest-neighbors with NO periodic boundary conditions
% this gives us strict edges
%
% caution:
%
%  if m = 2 then patch 1 is connected to patch 2 twice

if (m > 1)

  NN = zeros(m^2, 5);

  % upper left entry
  i = 1;
  NN(i, :) = [i, i + 1, i, i + m, i];

  % top row
  for i = 2 : m - 1
    NN(i, :) = [i, i - 1, i + 1, i + m, i];
  end

  % upper right entry
  i = m;
  NN(i, :) = [i, i, i - 1, i + m, i];

  % left side
  for j = 2 : m - 1
    for i = j * m 
      NN(j * m, :) = [i, i - m, i - 1, i,  i + m];
    end
  end

  % middle entries
  for j = 1 : m - 2
    for i = j * m + 2 : (j + 1) * m - 1
      NN(i, :) = [i, i - m, i - 1,  i + 1, i + m];
    end
  end

  % right side
  for j = 1 : m - 2
    for i = j * m + 1
      NN(j * m + 1, :) = [i, i - m, i + 1, i, i + m];
    end
  end

  % lower left entry
  i = (m - 1) * m + 1;
  NN(i, :) = [i,i, i - m,  i + 1, i];

  % bottom row
  for i = (m - 1) * m + 2 : m^2 - 1
    NN(i, :) = [i, i, i - m, i - 1,  i + 1];
  end

  % lower right entry
  i = m^2;
  NN(i, :) = [i, i, i - m, i, i - 1];

end