% parameters.m
%
% no user srevice-able parts

% Checked 6/15/2015 JH

% Here you will find the extraneous components of preferences.m 
% Do not change these values!

% maximum time (in years)

Time_horizon = 15;               % later, we call this tmax

% habitats

    % landscape (this is the length of an edge)
        
    m = 20;                     % note: number of patches is
                                % L_size = m^2

% composition 

% number of initial cells for percolation 
        
        percolation_cell = 2;

        % probability of transformation for boundary cells
        
            prob_trans_0 = 0;           % zero edges
            prob_trans_1 = 0.2;         % one edge
            prob_trans_2 = 0.4;         % two edges
            prob_trans_3 = 0.6;         % three edges
            prob_trans_4 = 0.8;         % four edges

     % vegetation data for canopy cover (from log-normal distribution)
        veg_mean_forest = 86;
        veg_sd_forest = 5;
        veg_mean_coffee = 70;
        veg_sd_coffee = 21;        
            
   
    
% birds

    % adults

    N_0 = 15;                           % initial bird populations 
    
    wing_length_mean = 59.4;            % wing length distribution
    wing_length_sd = 2.21;
    
    weight_source_mean = 11.5;          % weight distribution sources/forest
    weight_source_sd = 0.51;
    
    weight_sink_mean = 9.5;             % weight distribtution sinks/coffee
    weight_sink_sd = 0.51;
    
    weight_floater_mean = 10.5;
    weight_floater_sd = 0.51;
    
    % juveniles per habitat breeding site (from binomial distribution)

    size_source=6;
    prob_source=0.8;

    size_sink=3;    
    prob_sink=0.65;

    % survival rates

    psA = 0.6;                  % survival probability for adults
    psJ = 0.1;                  % survival probability for juveniles
    
        % survival probability for floaters are density dependent
        % NOTE: psF is located in winter.m
        
            % this parameter represents the (on average) number of floaters
            % that can occupy a cell with psF = psA
                floater_cc = 1;
            % this parameter represents the (on average) number of floaters
            % that can not survive if occupying a single cell
                floater_max = 3;
% dispersal
    % number of patches searched (from the available patches)
    if (search == 1)
        mm = 9;
    elseif (search == 2)
        mm = 25;
    elseif (search == 3)
        mm = 49;
    elseif (search == 4)
        mm = 81;
    end
    
% no animation = 0
% show animation = 1
% for better animations, select fewer simulations
% no composition = 0
% show composition = 1

    show_animation = 0;
    
    show_composition = 0;
    
    animation_delay = .5;   % this slows the animations for better viewing
    

    
% Additional Parameters
M = 30;                         % number of simulations

L_size = m^2;                   % number of patches

tmax = Time_horizon;
composition = configuration;
canopy = habitat_type;
% prop_coffee = composition;

prop_forest = 1 - prop_coffee;  % these are placed here so the user
prop_source = prop_forest;      % doesn't pick something that doesn't equal
prop_sink = prop_coffee;        % 1



%preconditioning
sim_total_population = zeros(M, tmax);
sim_source_population = zeros(M, tmax);
sim_sink_population = zeros(M, tmax);
sim_initial_source_population = zeros(M, 1);
sim_initial_sink_population = zeros(M, 1);
sim_initial_total_population = zeros(M, 1);