% breeding.m
%
% Checked 06/16/2015 JH
%
% breeding season

if (t == 1)
    for k = 1:size(BIRD_IDENTITIES,1);
        rr = ceil(1000.*rand(100,1));               % generates random number
        
                                                    % if there is a bird
                                                    % AND it is in a source
        if (BIRD(t, BIRD_IDENTITIES(k, 5)) == 1 && ... 
                SOURCE(1, BIRD_IDENTITIES(k, 5)) == 1)
                                                    % pulls sample from the
                                                    % distribution
            JUVENILE(t, BIRD_IDENTITIES(k, 5)) = ...
                offspring_source(rr(1));
                                                    % makes young
            BIRD_IDENTITIES(k, 7) = offspring_source(rr(1));
            
            
             ii = length(BIRD_IDENTITIES);
             pp = BIRD_IDENTITIES(length(BIRD_IDENTITIES),1);
             
            for jj = 1 : BIRD_IDENTITIES(k, ff + 3);
                                                    % all juveniles are
                                                    % added to the system,
                                                    % given wing lengths,
                                                    % weights and birth
                                                    % patches
                BIRD_IDENTITIES(ii + jj, 1) = pp + jj;
                BIRD_IDENTITIES(ii + jj, 2) = ... 
                    normrnd(wing_length_mean, wing_length_sd);
                BIRD_IDENTITIES(ii + jj, hh + 3) = ...
                    BIRD_IDENTITIES(k, hh + 3);
                BIRD_IDENTITIES(ii + jj, gg + 3) = ... 
                    normrnd(weight_source_mean, weight_source_sd)/ ...
                    BIRD_IDENTITIES(ii + jj, 2);
            end
                                                    % if there is a bird
                                                    % AND it is in a sink
        elseif (BIRD(t, BIRD_IDENTITIES(k, 5)) == 1 && ... 
                SOURCE(1, BIRD_IDENTITIES(k, 5)) == 0)
                                                    % pulls sample from the
                                                    % distribution
            JUVENILE(t, BIRD_IDENTITIES(k, 5)) = offspring_sink(rr(1));
                                                    % makes young
            BIRD_IDENTITIES(k, 7) = offspring_sink(rr(1));
            
             ii = length(BIRD_IDENTITIES);
             pp = BIRD_IDENTITIES(length(BIRD_IDENTITIES),1);
            
            for jj = 1 : BIRD_IDENTITIES(k, ff + 3);
                                                    % all juveniles are
                                                    % added to the system,
                                                    % given wing lengths,
                                                    % weights and birth
                                                    % patches        
                BIRD_IDENTITIES(ii + jj, 1) = pp + jj;
                BIRD_IDENTITIES(ii + jj, 2) = ...
                    normrnd(wing_length_mean, wing_length_sd);
                BIRD_IDENTITIES(ii + jj, hh + 3) = BIRD_IDENTITIES(k, hh + 3);
                BIRD_IDENTITIES(ii + jj, gg + 3) = ... 
                    normrnd(weight_sink_mean, weight_sink_sd)/...
                    BIRD_IDENTITIES(ii + jj, 2);
            end
        end               
    end

    % view the habitat (juvniles present = 1)
    for jj = 1:m;
        JUVENILEinitial(jj, :) = JUVENILE(1, (m - (m- (jj-1)))*m +1 : jj*m);
    end



% parameters for winter.m
post_breeding_population(t) = length(find(BIRD_IDENTITIES(:, gg + 3)));
post_breeding_juveniles(t) = length(BIRD_IDENTITIES(:, gg + 3));
else    % t >= 2
 
    BIRD(t, :) = BIRD(t-1, :);                      % resets after the census

    for k = 1:length(BIRD_IDENTITIES);
        rr = ceil(1000.*rand(100,1));               
                                                    % if this patch has a
                                                    % bird, that is not a floater
                                                    % AND it is a source,
                                                    % then it has offspring
                                                    % and that number of
                                                    % offspring is added to
                                                    % bird identities
        if (BIRD_IDENTITIES(k, hh + 3)> 0 && ... 
                BIRD(t, BIRD_IDENTITIES(k, hh + 3)) == 1 && ... 
                SOURCE(1, BIRD_IDENTITIES(k, hh + 3)) == 1)     
            
            JUVENILE(t, BIRD_IDENTITIES(k, hh + 3)) = offspring_source(rr(1));
            BIRD_IDENTITIES(k, ff + 3) = offspring_source(rr(1));
            
                  ii = length(BIRD_IDENTITIES);
                  pp = BIRD_IDENTITIES(length(BIRD_IDENTITIES),1);
            
                for jj = 1 : BIRD_IDENTITIES(k, ff + 3);
                                                    % all juveniles are
                                                    % added to the system,
                                                    % given wing lengths,
                                                    % weights and birth
                                                    % patches
                    BIRD_IDENTITIES(ii + jj, 1) = pp + jj;
                    BIRD_IDENTITIES(ii + jj, 2) = ...
                        normrnd(wing_length_mean, wing_length_sd);
                    BIRD_IDENTITIES(ii + jj, hh + 3) = BIRD_IDENTITIES(k, hh + 3);
                    BIRD_IDENTITIES(ii + jj, gg + 3) = ... 
                        normrnd(weight_source_mean, weight_source_sd)/ ...
                        BIRD_IDENTITIES(ii + jj, 2);
                end
            
                                                    % same as above, but if
                                                    % it is a sink 
        elseif (BIRD_IDENTITIES(k, hh + 3)> 0 && ... 
                BIRD(t, BIRD_IDENTITIES(k, hh + 3)) == 1 && ... 
                SOURCE(1, BIRD_IDENTITIES(k, hh + 3)) == 0)
            
            JUVENILE(t, BIRD_IDENTITIES(k, hh + 3)) = offspring_sink(rr(1));
            BIRD_IDENTITIES(k, ff + 3) = offspring_sink(rr(1));
            
             ii = length(BIRD_IDENTITIES);
             pp = BIRD_IDENTITIES(length(BIRD_IDENTITIES),1);
            
                for jj = 1 : BIRD_IDENTITIES(k, ff + 3);
                                                    % all juveniles are
                                                    % added to the system,
                                                    % given wing lengths,
                                                    % weights and birth
                                                    % patches        
                    BIRD_IDENTITIES(ii + jj, 1) = pp + jj;
                    BIRD_IDENTITIES(ii + jj, 2) = ...
                        normrnd(wing_length_mean, wing_length_sd);
                    BIRD_IDENTITIES(ii + jj, hh + 3) = BIRD_IDENTITIES(k, hh + 3);
                    BIRD_IDENTITIES(ii + jj, gg + 3) = ...
                        normrnd(weight_sink_mean, weight_sink_sd)/ ...
                        BIRD_IDENTITIES(ii + jj, 2);
                end
            
        end       
        
        
        
    end
    

% parameters for winter.m
post_breeding_population(t) = length(find(BIRD_IDENTITIES(:, gg + 3)));
post_breeding_juveniles(t) = length(BIRD_IDENTITIES(:, gg + 3));
end    
