% collect_bird_identities.m
%
% pull information from BIRD_IDENTITIES matrix
% recover information regarding juveniles
%
% Checked and Changed 07/27/2015 JH
%
% We need the birds' MEAN SIZE in forest (and coffee) each year
%
% The Following has been commented out and is no longer used:
% We need, for each bird, the number of years lived
%   in forest
%   in coffee
%   as a floater

% BI = [bird patch size young year habitat];
% habitat: source = 1, sink = 0
BI = zeros(1,5);
count = 0;

for time = 1 : tmax; 
    ggg = 3*time;                 
    hhh = ggg - 1;              
    fff = ggg + 1;               
    
    for kk = 1 : length(BIRD_IDENTITIES);
     
        if (BIRD_IDENTITIES(kk, fff + 3) ~= 0 || ...
                BIRD_IDENTITIES(kk, hhh + 3) ~= 0 || ...
                BIRD_IDENTITIES(kk, ggg + 3) ~= 0)
            count = count + 1;
            BI(count, :) = [BIRD_IDENTITIES(kk, 1) ...
                BIRD_IDENTITIES(kk, hhh + 3) ...
                BIRD_IDENTITIES(kk, ggg + 3) ...
                BIRD_IDENTITIES(kk, fff + 3) time];

        end
        
    end
end

remove = zeros(1);
count = 0;
for kk = 1 : length(BI);
    if (BI(kk, 1) == 0 && BI(kk, 2) == 0 && BI(kk, 3) == 0 ... 
            && BI(kk, 4) == 0 && BI(kk, 5) == 0)
        count = count + 1;
        remove(kk) = kk;
    end
end
    
remove(remove == 0) = [];

remove = sort(remove', 'descend');

for kk = 1 : length(remove);
    BI(remove(kk), :) = [];
end

% adds habitat type to the BI matrix
for kk = 1 : length(BI);
    if (BI(kk, 2) >0 && SOURCE(1, BI(kk, 2)) == 1)
        BI(kk, 6) = 1;
    elseif (BI(kk, 2) >0 && SOURCE(1, BI(kk, 2)) == 0)
        BI(kk, 6) = 0;
    else
        BI(kk, 6) = BI(kk, 2);
    end
end

adults_source_size(sim, 1:tmax) = 0;
adults_sink_size(sim, 1:tmax) = 0;
total_floater_size(sim, 1:tmax) = 0;
floater_forest_size(sim, 1:tmax) = 0;
floater_coffee_size(sim, 1:tmax) = 0;

mean_size_adults_forest(sim, 1:tmax) = 0;
mean_size_adults_coffee(sim, 1:tmax) = 0;
mean_size_adults_floaters(sim, 1:tmax) = 0;
mean_size_floaters_forest(sim, 1:tmax) = 0;
mean_size_floaters_coffee(sim, 1:tmax) = 0;

for jj = 1:tmax
    count_adults_source(jj) = 0;
    count_adults_sink(jj) = 0;
    count_floater(jj) = 0;
    forest_floater(jj) = 0;
    coffee_floater(jj) = 0;
  
for kk = 1 : length(BI);
    if BI(kk, 5) == jj;
        if (BI(kk, 3)>0 && BI(kk, 6) == 1)
            adults_source_size(sim, jj) = adults_source_size(sim, jj) + BI(kk, 3);
            count_adults_source(jj) = count_adults_source(jj) + 1;
        end
        if (BI(kk, 3)>0 && BI(kk, 6) == 0)
            adults_sink_size(sim, jj) = adults_sink_size(sim, jj) + BI(kk, 3);
            count_adults_sink(jj) = count_adults_sink(jj) + 1;
        end
        if (BI(kk, 3)>0 && BI(kk, 6) < 0)
            total_floater_size(sim, jj) = total_floater_size(sim, jj) + BI(kk, 3);
            count_floater(jj) = count_floater(jj) +1;
        end
        if (BI(kk, 3)>0 && BI(kk, 6) == -2)
            floater_forest_size(sim, jj) = floater_forest_size(sim, jj) + BI(kk, 3);
            forest_floater(jj) = forest_floater(jj) + 1;
        end
        if (BI(kk, 3)>0 && BI(kk, 6) == -3)
            floater_coffee_size(sim, jj) = floater_coffee_size(sim, jj) + BI(kk, 3);
            coffee_floater(jj) = coffee_floater(jj) + 1;
        end
    end
end



mean_size_adults_forest(sim, jj) = adults_source_size(sim, jj)/count_adults_source(jj);
mean_size_adults_coffee(sim, jj) = adults_sink_size(sim, jj)/count_adults_sink(jj);
mean_size_adults_floaters(sim, jj) = total_floater_size(sim, jj)/count_floater(jj);
mean_size_floaters_forest(sim, jj) = floater_forest_size(sim, jj)/forest_floater(jj);
mean_size_floaters_coffee(sim, jj) = floater_coffee_size(sim, jj)/coffee_floater(jj);
total_source_mean_size(sim, jj) = (adults_source_size(sim, jj) + floater_forest_size(sim, jj)) ...
    / (count_adults_source(jj) + forest_floater(jj));
total_sink_mean_size(sim, jj) = (adults_sink_size(sim, jj) + floater_coffee_size(sim, jj)) ...
    / (count_adults_sink(jj) + coffee_floater(jj));
end

mean_size_adults_forest(isnan(mean_size_adults_forest)) = 0;
mean_size_adults_coffee(isnan(mean_size_adults_coffee)) = 0;
mean_size_adults_floaters(isnan(mean_size_adults_floaters)) = 0;
mean_size_floaters_forest(isnan(mean_size_floaters_forest)) = 0;
mean_size_floaters_coffee(isnan(mean_size_floaters_coffee)) = 0;

var_size_adults_forest = var(mean_size_adults_forest, 1);
var_size_adults_coffee = var(mean_size_adults_coffee, 1);
var_size_adults_floaters = var(mean_size_adults_floaters, 1);
var_size_floaters_forest = var(mean_size_floaters_forest, 1);
var_size_floaters_coffee = var(mean_size_floaters_coffee, 1);
var_total_source_mean_size = var(total_source_mean_size, 1);
var_total_sink_mean_size = var(total_sink_mean_size, 1);

% pollitos
d = size(BIRD_IDENTITIES);
s = (5:3:d(2)-3);
ds = size(s);

w = max(find(BIRD_IDENTITIES(:,s(1))>0));
list = BIRD_IDENTITIES(N_0+1:w,s(1)) ;
v = unique(list);
c = hist(list,v);
hab = SOURCE(1,v(1:end));
pollitos_sink_one(sim, :) = mean(c(hab==0));
pollitos_source_one(sim, :) = mean(c(hab==1));

for j = 2:ds(2)
  w(1,j-1) = max(find(BIRD_IDENTITIES(:,s(j-1))>0))+1;
  w(2,j-1) = max(find(BIRD_IDENTITIES(:,s(j))>0));
  list = BIRD_IDENTITIES(w(1,j-1):w(2,j-1),s(j)) ;
  v = unique(list);
  c = hist(list,v);
  hab = SOURCE(1,v(1:end));
  pollitos_sink(sim,j-1) = mean(c(hab==0));
  pollitos_source(sim,j-1) = mean(c(hab==1));
end

sim_pollitos_sink(sim, :) = horzcat(pollitos_sink_one(sim, :), pollitos_sink(sim, :));
sim_pollitos_source(sim, :) = horzcat(pollitos_source_one(sim, :), pollitos_source(sim, :));

