% initial_conditions.m
%
% no user-serviceable parts
%
% Checked 06/16/2015 JH

if (t == 1)

% BIRD IDENTITIES

BIRD_IDENTITIES = zeros(1,4);

wing_length = zeros(1);                             % wing length is determined
weight_source = zeros(1);                           % initial weight is chosen
                                                    % as a source
                                                    % population
for kk = 1:N_0;
    wing_length(kk) = normrnd(wing_length_mean, wing_length_sd);
    weight_source(kk) = normrnd(weight_source_mean, weight_source_sd);
    BIRD_IDENTITIES(kk,:) = [kk wing_length(kk) weight_source(kk) ...
        weight_source(kk)/wing_length(kk)];
end

                                                    % ranks birds from
                                                    % largest to smallest
[bird_sizes, order_sizes] = sort(BIRD_IDENTITIES(:,4),'descend');   

% BIRDS 

for k = 1 : N_0;                                    % randomizes the birds
    space_BIRD(k, :) = randperm(L_size);            % search for habitat
end

for kk = 1:N_0;
    
    rm = L_size - (kk - 1);                         % remaining patches
    MM = min(rm, mm);                               % number of patches searched
    
    for jj = 1:L_size;                              % determines spots that 
        if (BIRD(1, space_BIRD(kk, jj)) == 0)        % have no bird and are
            spot_BIRD(kk, jj) = space_BIRD(kk, jj); % available for selection
        end                                         % This is computed for each
                                                    % bird after the
                                                    % previous bird settles
    end
        
    row_spot_BIRD = spot_BIRD(kk, :);
    new_spot_BIRD = row_spot_BIRD(row_spot_BIRD ~=0);
    
    patch_found = 0;                                % patches are chosen
    jj = 1;

    if (preferred_habitat == 0 )
        BIRD(1, new_spot_BIRD(1)) = 1;
        bird_location(kk) = new_spot_BIRD(jj);
        
  
    elseif (preferred_habitat == 1)
        while (jj <= MM && patch_found == 0)
            if (SOURCE(1, new_spot_BIRD(jj))== 1 || jj == MM)
                patch_found = 1;
                BIRD(1, new_spot_BIRD(jj)) = 1;
                bird_location(kk) = new_spot_BIRD(jj);
            end
    
            jj = jj + 1;
        end
        
    elseif (preferred_habitat == 2)
        while (jj <= MM && patch_found == 0)
            if (SOURCE(1, new_spot_BIRD(jj))== 0 || jj == MM)
                patch_found = 1;
                BIRD(1, new_spot_BIRD(jj)) = 1;
                bird_location(kk) = new_spot_BIRD(jj);
            end
 
            jj = jj + 1;
        end
        
    elseif (preferred_habitat == 3)
       while (jj <= MM && patch_found == 0)
            if (CANOPY(1, new_spot_BIRD(jj)) >= preferred_cover || jj == MM)
                patch_found = 1;
                BIRD(1, new_spot_BIRD(jj)) = 1;
                bird_location(kk) = new_spot_BIRD(jj);
            end
 
            jj = jj + 1;
       end
    
    end
       
end
                                                    % patches chosen are
                                                    % assigned to the
                                                    % largest birds first
for kk = 1: N_0;
    BIRD_IDENTITIES(order_sizes(kk), 5) = bird_location(kk);
                                                    % new weights are
                                                    % assigned from these
                                                    % new patches
    if (SOURCE(1, bird_location(kk)) == 1)
        BIRD_IDENTITIES(order_sizes(kk),6) = ...
            normrnd(weight_source_mean, weight_source_sd)/...
            BIRD_IDENTITIES(order_sizes(kk),2);
    elseif (SOURCE(1, bird_location(kk)) == 0)
        BIRD_IDENTITIES(order_sizes(kk),6) = ...
            normrnd(weight_sink_mean, weight_sink_sd)/...
            BIRD_IDENTITIES(order_sizes(kk),2);
    end
end



% view the habitat (sources = 1, sinks = 0, birds present = 1)
for jj = 1:m;
    SOURCEinitial(jj, :) = SOURCE(1, (m - (m- (jj-1)))*m +1 : jj*m);
    BIRDinitial(jj, :) = BIRD(1, (m - (m- (jj-1)))*m +1 : jj*m);
end

for ii = 1:m;
    for jj = 1:m;
        if (BIRDinitial(ii, jj) == 1 && SOURCEinitial(ii, jj) == 1)
            BIRDinitialSOURCE(ii, jj) = 1;
        elseif (BIRDinitial(ii, jj) == 1&& SOURCEinitial(ii, jj) == 0)
            BIRDinitialSINK(ii, jj) = 1;
        end       
    end
end

end

gg = 3*t;                   % iterates on bird identities sizes
hh = gg - 1;                % iterates on bird identities patches
ff = gg + 1;                % iterates on bird identities young