% landscape_composition.m
%
% Checked 06/16/2015 JH

% categorical 
if (canopy == 0)
% random
           SOURCE_graf = zeros(m, m, 3);
if (composition == 0)
    
    % coffee cells are determined (as zeros)                  
    TOTAL = randperm(L_size);                           % picks spots for sources 
    spot_COFFEE = TOTAL(1:round(L_size*prop_coffee));   % randomly
    
    % lanscape is generated
    for kk = 1 : L_size*prop_coffee;
        SOURCE(1, spot_COFFEE(kk)) = 0;
    end

    % landscape composition animation
    if (show_composition == 1)
        SOURCE_graf = zeros(m, m, 3);
        for jj = 1 : m
            if (max(max(SOURCE)) > 0)
                SOURCE_graf(jj, :, 2) =  ...
                    SOURCE(1, (m - (m- (jj-1)))*m +1 : jj*m) / max(max( SOURCE));
            else
                SOURCE_graf(jj, :, 2) =  ...
                SOURCE(1, (m - (m- (jj-1)))*m +1 : jj*m);
            end
        end

        figure(1)

        subplot(1, M, sim);image(SOURCE_graf)
        title(sprintf('Sources are light, Sinks are dark'))
        pause(animation_delay)
        
    end


% lateral
elseif (composition == 1)
    % initial
    
    for jj = 1 : m
        SOURCE(1,(jj - 1)*m + 1) = 0;
    end
    
% radial
elseif (composition == 2)   
    % initial
    
    SOURCE(1, 1) = 0;

% percolation
elseif (composition == 3)
    initial_percolation = randperm(L_size);
    
    for kk = 1 : percolation_cell;
        SOURCE(1, initial_percolation(kk)) = 0;
    end

end

h = 2;          
% Note: h represents the number of iterations it takes for the 
% landscape to have desired proportion of coffee
% lanscape is generated for lateral, radial, or percolation
if (composition > 0)
    while (sum(SOURCE(h - 1,:)) > L_size - round(L_size*prop_coffee))
        transform_patches = zeros(L_size,3);
        SOURCE(h, :) = SOURCE(h - 1, :);
        
        % for each patch near a coffee patch, we determine the number of 
        % forest edges from the previous iteration
        
        for ii = 1 : L_size;
            forest_edges = 0;
            for jj = 2 : 5;
                if (SOURCE(h, NN(ii, 2)) == 0 || SOURCE(h, NN(ii, 3)) == 0 ...
                        || SOURCE(h, NN(ii, 4)) == 0 || SOURCE(h, NN(ii, 5)) == 0 ...
                        && SOURCE(h, NN(ii, jj)) == 1)
                    forest_edges = forest_edges + 1;
                end
            end
            transform_patches(ii, :) = [ii forest_edges 0];
        end
        
        % assign these patches the appropriate probabilities of
        % transformation
        
        for ii = 1 : L_size;
            if (transform_patches(ii, 2) == 0)
                transform_patches(ii, 3) = prob_trans_0;
            elseif (transform_patches(ii, 2) == 1)
                transform_patches(ii, 3) = prob_trans_1;                
            elseif (transform_patches(ii, 2) == 2)
                transform_patches(ii, 3) = prob_trans_2;                
            elseif (transform_patches(ii, 2) == 3)
                transform_patches(ii, 3) = prob_trans_3;
            elseif (transform_patches(ii, 2) == 4)
                transform_patches(ii, 3) = prob_trans_4; 
            end
        end
        
        % give each patch a random number
        prob_trans = rand(1, L_size);
        
        % transform patches
        for ii = 1 : L_size;
            if (transform_patches(ii,3) ~= 0 && ...
                    prob_trans(ii) <= transform_patches(ii, 3))
                SOURCE(h, ii) = 0;
            end
        end 
        
        % landscape animation
        if (show_composition == 1)
%             SOURCE_graf = zeros(m, m, 3);

            for jj = 1 : m
                if (max(max(SOURCE)) > 0)
                    SOURCE_graf(jj, :, 2) =  ...
                        SOURCE(h, (m - (m- (jj-1)))*m +1 : jj*m) / ...
                        max(max( SOURCE));
                else
                    SOURCE_graf(jj, :, 2) =  ...
                        SOURCE(h, (m - (m- (jj-1)))*m +1 : jj*m);
                end
            end

            figure(1)

            subplot(1, M, sim);image(SOURCE_graf)
            title(sprintf('Sources are light, Sinks are dark'))
            pause(1)
        end
        h = h + 1;
    end
    SOURCE(1, :) = SOURCE(h-1, :);
end

end

% canopy percent cover

if (canopy == 1)

% random
           SOURCE_graf = zeros(m, m, 3);
           CANOPY_graf = zeros(m, m, 3);
if (composition == 0)
    
    % coffee cells are determined (as zeros)                  
    TOTAL = randperm(L_size);                           % picks spots for sources 
    spot_COFFEE = TOTAL(1:round(L_size*prop_coffee));   % randomly
    
    % lanscape is generated
    for kk = 1 : L_size*prop_coffee;
        rr = ceil(length(vegetation_sink).*rand(100,1)); 
        SOURCE(1, spot_COFFEE(kk)) = 0;
        CANOPY(1, spot_COFFEE(kk)) = vegetation_sink(rr(1));
    end

    % landscape composition animation
    if (show_composition == 1)
        CANOPY_graf = zeros(m, m, 3);
        for jj = 1 : m
            if (max(max(CANOPY)) > 0)
                CANOPY_graf(jj, :, 2) =  ...
                    CANOPY(1, (m - (m- (jj-1)))*m +1 : jj*m) / max(max( CANOPY));
            else
                CANOPY_graf(jj, :, 2) =  CANOPY(1, (m - (m- (jj-1)))*m +1 : jj*m);
            end
        end

        figure(1)

        subplot(1, M, sim);image(CANOPY_graf)
        title(sprintf('Higher canopy cover is darker'))
        pause(animation_delay)
        
    end


% lateral
elseif (composition == 1)
    % initial
    
    for jj = 1 : m
        rr = ceil(length(vegetation_sink).*rand(100,1));
        SOURCE(1,(jj - 1)*m + 1) = 0;
        CANOPY(1,(jj - 1)*m + 1) = vegetation_sink(rr(1));
    end
    
% radial
elseif (composition == 2)   
    % initial
    
    rr = ceil(length(vegetation_sink).*rand(100,1));
    SOURCE(1, 1) = 0;
    CANOPY(1, 1) = vegetation_sink(rr(1));

% percolation
elseif (composition == 3)
    initial_percolation = randperm(L_size);
    
    for kk = 1 : percolation_cell;
        rr = ceil(length(vegetation_sink).*rand(100,1));
        SOURCE(1, initial_percolation(kk)) = 0;
        CANOPY(1, initial_percolation(kk)) = vegetation_sink(rr(1));
    end

end

h = 2;
% lanscape is generated for lateral, radial, or percolation
if (composition > 0)
    while (sum(SOURCE(h - 1,:)) > L_size - round(L_size*prop_coffee))
        transform_patches = zeros(L_size,3);
        SOURCE(h, :) = SOURCE(h - 1, :);
        CANOPY(h, :) = CANOPY(h - 1, :);
        
        % for each patch near a coffee patch, we determine the number of 
        % forest edges from the previous iteration
        
        for ii = 1 : L_size;
            forest_edges = 0;
            for jj = 2 : 5;
                if (SOURCE(h, NN(ii, 2)) == 0 || SOURCE(h, NN(ii, 3)) == 0 ...
                        || SOURCE(h, NN(ii, 4)) == 0 || ...
                        SOURCE(h, NN(ii, 5)) == 0 && SOURCE(h, NN(ii, jj)) == 1)
                    forest_edges = forest_edges + 1;
                end
            end
            transform_patches(ii, :) = [ii forest_edges 0];
        end
        
        % assign these patches the appropriate probabilities of
        % transformation
        
        for ii = 1 : L_size;
            if (transform_patches(ii, 2) == 0)
                transform_patches(ii, 3) = prob_trans_0;
            elseif (transform_patches(ii, 2) == 1)
                transform_patches(ii, 3) = prob_trans_1;                
            elseif (transform_patches(ii, 2) == 2)
                transform_patches(ii, 3) = prob_trans_2;                
            elseif (transform_patches(ii, 2) == 3)
                transform_patches(ii, 3) = prob_trans_3;
            elseif (transform_patches(ii, 2) == 4)
                transform_patches(ii, 3) = prob_trans_4; 
            end
        end
        
        % give each patch a random number
        prob_trans = rand(1, L_size);
        
        % transform patches
        for ii = 1 : L_size;
            rr = ceil(length(vegetation_sink).*rand(100,1));
            if (transform_patches(ii,3) ~= 0 && ...
                    prob_trans(ii) <= transform_patches(ii, 3))
                SOURCE(h, ii) = 0;
                CANOPY(h, ii) = vegetation_sink(rr(1));
            end
        end 
        
        % landscape animation
        if (show_composition == 1)
%             SOURCE_graf = zeros(m, m, 3);
%             CANOPY_graf = zeros(m, m, 3);
            for jj = 1 : m
                if (max(max(SOURCE)) > 0)
                    CANOPY_graf(jj, :, 2) =  ...
                        CANOPY(h, (m - (m- (jj-1)))*m +1 : jj*m) /...
                        max(max( CANOPY));
                else
                    CANOPY_graf(jj, :, 2) =  ...
                        CANOPY(h, (m - (m- (jj-1)))*m +1 : jj*m);
                end
            end

            figure(1)
            
            CANOPY_graf(:, :, 2) = 1 - CANOPY_graf(:, :, 2);
%                \
            subplot(1, M, sim);image(CANOPY_graf)
            title(sprintf('Higher canopy is darker'))
            pause(1)
        end
        h = h + 1;
    end
    SOURCE(1, :) = SOURCE(h-1, :);
    CANOPY(1, :) = CANOPY(h-1, :);
    % Here, we re-write the first iteration of the matrix so that it is
    % easier to call later (we don't have to call h because it changes with
    % each simulation and is arbitrary.
    % This does not alter the simulation, but it does delete the first
    % iteration's data.
end
 
end