% User ONLY changes the filename below. Nothing else. 
% Use the following format: 
% hab_#_config_#_prop_#_prefhab_#_prefcov_#_search_#_initials.xlsx
% where the # refers to the number you defined for the simulation (NO DECIMALS) 
% hab is habitat_type
% config is configuration
% prop is prop_coffee (NO DECIMAL)
% prefhab is preferred_habitat
% prefcov is preferred_cover (NO DECIMAL) ***
% search is search distance
% initials is your first and last initial, example JH
%
% For example:
% filename = ' hab_1_config_2_prop_20_prefhab_1_prefcov_0_search_1_JH.xlsx'
% has habitat_type = 1, configuration = 2, prop_coffee = 0.2
% preferred_habitat = 1, preferred_cover = 0, search = 1, done by Jessica Hearns = JH 
%
% ***Note: only half the simulations will include preferred_cover. If your row
% does not have preferred_cover, set that value equal to 0. Only change it
% if you have a preferred_cover simulation. 
%
% Checked and Changed 07/09/2015 JH
% Checked and Changed 08/27/2015 LS


filename = 'hab_1_config_2_prop_10_prefhab_3_prefcov_30_search_2_REP.xlsx';

A = {'Habitat Type', 'Configuration','Proportion Coffee', 'Preferred Habitat', ...
    'Preferred Cover', 'Search Distance';...
    habitat_type, configuration, prop_coffee, preferred_habitat, preferred_cover, ...
    search};
sheet = 1;
xlRangeA = 'A1';
xlswrite(filename, A, sheet, xlRangeA);

B = {'Years', 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15};
xlRangeB = 'L3';
xlswrite(filename, B, sheet, xlRangeB);
xlRangeBB = 'AE3';
xlswrite(filename, B, sheet, xlRangeBB);
xlRangeBBB = 'AX3';
xlswrite(filename, B, sheet, xlRangeBBB);
xlRangeBBBB = 'BQ3';
xlswrite(filename, B, sheet, xlRangeBBBB);

C = {'Simulation'};
xlRangeC = 'K5';
xlswrite(filename, C, sheet, xlRangeC);
xlRangeCc = 'K57';
xlswrite(filename, C, sheet, xlRangeCc);
xlRangeCcc = 'K109';
xlswrite(filename, C, sheet, xlRangeCcc);
xlRangeCccc = 'K161';
xlswrite(filename, C, sheet, xlRangeCccc);
xlRangeCcccc = 'K212';
xlswrite(filename, C, sheet, xlRangeCcccc);
xlRangeCC = 'AD5';
xlswrite(filename, C, sheet, xlRangeCC);
xlRangeCCc = 'AD57';
xlswrite(filename, C, sheet, xlRangeCCc);
xlRangeCCcc = 'AD109';
xlswrite(filename, C, sheet, xlRangeCCcc);
xlRangeCCccc = 'AD161';
xlswrite(filename, C, sheet, xlRangeCCccc);
xlRangeCCcccc = 'AD212';
xlswrite(filename, C, sheet, xlRangeCCcccc);
xlRangeCCC = 'AW5';
xlswrite(filename, C, sheet, xlRangeCCC);
xlRangeCCCc = 'AW57';
xlswrite(filename, C, sheet, xlRangeCCCc);
xlRangeCCCC = 'BP5';
xlswrite(filename, C, sheet, xlRangeCCCC);
xlRangeCCCCc = 'BP57';
xlswrite(filename, C, sheet, xlRangeCCCCc);
xlRangeCCCCCc = 'BP109';
xlswrite(filename, C, sheet, xlRangeCCCCCc);
xlRangeCCCCCCc = 'BP161';
xlswrite(filename, C, sheet, xlRangeCCCCCCc);
xlRangeCCCCCCCc = 'BP213';
xlswrite(filename, C, sheet, xlRangeCCCCCCCc);

D = {1;2;3;4;5;6;7;8;9;10;11;12;13;14;15;16;17;18;19;20;21;22;23;24;25;...
    26;27;28;29;30;31;32;33;34;35;36;37;38;39;40;41;42;43;44;45;46;47;48;49;50};
xlRangeD = 'L5';
xlswrite(filename, D, sheet, xlRangeD);
xlRangeDd = 'L57';
xlswrite(filename, D, sheet, xlRangeDd);
xlRangeDdd = 'L109';
xlswrite(filename, D, sheet, xlRangeDdd);
xlRangeDddd = 'L161';
xlswrite(filename, D, sheet, xlRangeDddd);
xlRangeDdddd = 'L213';
xlswrite(filename, D, sheet, xlRangeDdddd);
xlRangeDD = 'AE5';
xlswrite(filename, D, sheet, xlRangeDD);
xlRangeDDd = 'AE57';
xlswrite(filename, D, sheet, xlRangeDDd);
xlRangeDDdd = 'AE109';
xlswrite(filename, D, sheet, xlRangeDDdd);
xlRangeDDddd = 'AE161';
xlswrite(filename, D, sheet, xlRangeDDddd);
xlRangeDDdddd = 'AE213';
xlswrite(filename, D, sheet, xlRangeDDdddd);
xlRangeDDD = 'AX5';
xlswrite(filename, D, sheet, xlRangeDDD);
xlRangeDDDd = 'AX57';
xlswrite(filename, D, sheet, xlRangeDDDd);
xlRangeDDDD = 'BQ5';
xlswrite(filename, D, sheet, xlRangeDDDD);
xlRangeDDDDd = 'BQ57';
xlswrite(filename, D, sheet, xlRangeDDDDd);
xlRangeDDDDDd = 'BQ109';
xlswrite(filename, D, sheet, xlRangeDDDDDd);
xlRangeDDDDDDd = 'BQ161';
xlswrite(filename, D, sheet, xlRangeDDDDDDd);
xlRangeDDDDDDDd = 'BQ213';
xlswrite(filename, D, sheet, xlRangeDDDDDDDd);

E = {'sim_total_population'};
xlRangeE = 'J4';
xlswrite(filename, E, sheet, xlRangeE);
xlRangeF = 'M5';
xlswrite(filename, sim_total_population, sheet, xlRangeF);

EE = {'sim_source_population'};
xlRangeEE = 'J56';
xlswrite(filename, EE, sheet, xlRangeEE);
xlRangeFF = 'M57';
xlswrite(filename, sim_source_population, sheet, xlRangeFF);

EEE = {'sim_sink_population'};
xlRangeEEE = 'J108';
xlswrite(filename, EEE, sheet, xlRangeEEE);
xlRangeFFF= 'M109';
xlswrite(filename, sim_sink_population, sheet, xlRangeFFF);

EEEE = {'sim_source_floater'};
xlRangeEEEE = 'J160';
xlswrite(filename, EEEE, sheet, xlRangeEEEE);
xlRangeFFFF = 'M161';
xlswrite(filename, sim_source_floater, sheet, xlRangeFFFF);

EEEEE = {'sim_sink_floater'};
xlRangeEEEEE = 'J212';
xlswrite(filename, EEEEE, sheet, xlRangeEEEEE);
xlRangeFFFFF = 'M213';
xlswrite(filename, sim_sink_floater, sheet, xlRangeFFFFF);

if (capture == 1)
    G = {'c_sim_total_population'};
    xlRangeG = 'AC4';
    xlswrite(filename, G, sheet, xlRangeG);
    xlRangeH = 'AF5';
    xlswrite(filename, c_sim_total_population, sheet, xlRangeH);

    GG = {'c_sim_source_population'};
    xlRangeGG = 'AC56';
    xlswrite(filename, GG, sheet, xlRangeGG);
    xlRangeHH = 'AF57';
    xlswrite(filename, c_sim_source_population, sheet, xlRangeHH);

    GGG = {'c_sim_sink_population'};
    xlRangeGGG = 'AC108';
    xlswrite(filename, GGG, sheet, xlRangeGGG);
    xlRangeHHH= 'AF109';
    xlswrite(filename, c_sim_sink_population, sheet, xlRangeHHH);

%     GGGG = {'c_sim_source_floater'};
%     xlRangeGGGG = 'AC160';
%     xlswrite(filename, GGGG, sheet, xlRangeGGGG);
%     xlRangeHHHH = 'AF161';
%     xlswrite(filename, c_sim_source_floater, sheet, xlRangeHHHH);
% 
%     GGGGG = {'c_sim_sink_floater'};
%     xlRangeGGGGG = 'AC212';
%     xlswrite(filename, GGGGG, sheet, xlRangeGGGGG);
%     xlRangeHHHHH = 'AF213';
%     xlswrite(filename, c_sim_sink_floater, sheet, xlRangeHHHHH);
end

J = {'sim_pollitos_source'};
xlRangeJ = 'AV4';
xlswrite(filename, J, sheet, xlRangeJ);
xlRangeK = 'AY5';
xlswrite(filename, sim_pollitos_source, sheet, xlRangeK);

JJ = {'sim_pollitos_sink'};
xlRangeJJ = 'AV56';
xlswrite(filename, J, sheet, xlRangeJJ);
xlRangeKK = 'AY57';
xlswrite(filename, sim_pollitos_sink, sheet, xlRangeKK);

P = {'total_source_mean_size'};
xlRangeP = 'BO4';
xlswrite(filename, P, sheet, xlRangeP);
xlRangeQ = 'BR5';
xlswrite(filename, total_source_mean_size, sheet, xlRangeQ);

Pp = {'var_total_source_mean_size'};
xlRangePp = 'BP55';
xlswrite(filename, Pp, sheet, xlRangePp);
xlRangeQq = 'BR55';
xlswrite(filename, var_total_source_mean_size, sheet, xlRangeQq);

PP = {'total_sink_mean_size'};
xlRangePP = 'BO56';
xlswrite(filename, PP, sheet, xlRangePP);
xlRangeQQ = 'BR57';
xlswrite(filename, total_sink_mean_size, sheet, xlRangeQQ);

PPp = {'var_total_sink_mean_size'};
xlRangePPp = 'BP107';
xlswrite(filename, PPp, sheet, xlRangePPp);
xlRangeQQq = 'BR107';
xlswrite(filename, var_total_sink_mean_size, sheet, xlRangeQQq);

PPP = {'mean_size_adults_floaters'};
xlRangePPP = 'BO108';
xlswrite(filename, PPP, sheet, xlRangePPP);
xlRangeQQQ = 'BR109';
xlswrite(filename, mean_size_adults_floaters, sheet, xlRangeQQQ);

PPPp = {'var_size_adults_floaters'};
xlRangePPPp = 'BP159';
xlswrite(filename, PPPp, sheet, xlRangePPPp);
xlRangeQQQq = 'BR159';
xlswrite(filename, var_size_adults_floaters, sheet, xlRangeQQQq);

PPPP = {'mean_size_adults_forest'};
xlRangePPPP = 'BO160';
xlswrite(filename, PPPP, sheet, xlRangePPPP);
xlRangeQQQQ = 'BR161';
xlswrite(filename, mean_size_adults_forest, sheet, xlRangeQQQQ);

PPPPp = {'var_size_adults_forest'};
xlRangePPPPp = 'BP211';
xlswrite(filename, PPPPp, sheet, xlRangePPPPp);
xlRangeQQQQq = 'BR211';
xlswrite(filename, var_size_adults_forest, sheet, xlRangeQQQQq);

PPPPP = {'mean_size_adults_coffee'};
xlRangePPPPP = 'BO212';
xlswrite(filename, PPPPP, sheet, xlRangePPPPP);
xlRangeQQQQQ = 'BR213';
xlswrite(filename, mean_size_adults_coffee, sheet, xlRangeQQQQQ);

PPPPPp = {'var_size_adults_coffee'};
xlRangePPPPPp = 'BP263';
xlswrite(filename, PPPPPp, sheet, xlRangePPPPPp);
xlRangeQQQQQq = 'BR263';
xlswrite(filename, var_size_adults_coffee, sheet, xlRangeQQQQQq);
